/* --- Copyright University of Birmingham 1995. All rights reserved. ------
 > File:            $poplocal/local/lib/newmatches.p
 > Purpose:			Replaces "matches" and related procedures with
 >					more general ones based on LIB DOESMATCH
 > Author:          Aaron Sloman, Dec 27 1995 (see revisions)
 > Documentation:	HELP * DOESMATCH, * READPATTERN
 > Related Files:	LIB * DOESMATCH, * WHILE_MATCHING, * READPATTERN
 > 						$usepop/pop/lib/database/ *.p
 */

/*

lib newmatches

If compiled this redefines matches and sysmatch in terms of newsysmatch
and doesmatch, both defined in LIB * DOESMATCH.

This library should be compiled BEFORE any database utilities that use
the matcher.

Also, in order to make the database procedure "which" work properly,
in combination with the "!" prefix, it needs to be re-defined, as
explained in HELP * READPATTERN/which


*/

section;
compile_mode: pop11+normal;

;;; Allow these to be redefined.
applist([matches sysmatch -->], sysunprotect);

global constant procedure (old_matches, old_sysmatch, old_arrow);

if isundef(old_matches) then
	nonop matches -> old_matches;
	sysmatch -> old_sysmatch;
	nonop --> -> old_arrow;
else
	pr(';;; WARNING: recompiling LIB NEWMATCHES')
endif;

uses doesmatch;

nonop doesmatch -> nonop matches;

newsysmatch -> sysmatch;

define global constant 8 datum --> pattern;
	lvars datum, pattern;

	unless datum doesmatch pattern then
		mishap(datum, pattern, 2, 'MISHAP - NON MATCHING ARGUMENTS FOR -->')
	endunless
enddefine;

applist([matches sysmatch -->], sysprotect);

global vars newmatches = true;	;;; for uses

endsection;
