/*********************************************************************

SIMWORLD
Version 4.0 Beta

Basic Rulesystems

Copyright (C) 2002 Matthias Scheutz (mscheutz@nd.edu)
Artificial Intelligence and Robotics Laboratory
Department of Computer Science and Engineering 
University of Notre Dame, USA
http://www.nd.edu/~mscheutz/ 
http://www.nd.edu/~airolab/ 
All rights reserved.

This program is licensed and distributed under the terms stated
in the accompanying COPYRIGHT file.

Last modified: 11-27-02

*********************************************************************/
compile_mode :pop11 +strict;

/*

define rulesystems for different agent types:

-- basic
-- affective
-- deliberative
-- combined
-- basic sharing
-- affective sharing
-- deliberative sharing
-- combined sharing

*/

;;; NOTE that the order of the rulesystems is crucial

;;; rulesystem for the basic agent
define :rulesystem basic_agent_rulesystem;
    ;;; Set a default cycle limit (number of times the rulesystem runs in each timeslice)
    cycle_limit = 1;

    ;;; unquote the following to be able to inspect the database
    ;;; include: printagentdatabase


    ;;; the basic components
    include: eating_ruleset
    include: drinking_ruleset
    include: energyalarm_ruleset
    include: coolantalarm_ruleset
    include: moving_ruleset
    include: collidereflex_ruleset
    include: cleanup_ruleset
enddefine;

